#include "gdt.h"
#include "tss.h"

gdt_entry gdt[GDT_COUNT] = {
	// Descriptor 0: reservado, nulo
	{0,0,0,0,0,0,0,0,0,0,0,0,0},

	// Descriptor 1: no dice que hacer, vacio
	{0,0,0,0,0,0,0,0,0,0,0,0,0},

	// Descriptor 2: codigo del kernel (4GB)
	{0xFFFF, 
		0x0000,
		0x00,
		0xA, //Ejecutable, Readable
		0x1, //no es de sistema
		0x0, //DPL=0
		0x1, //Presente
		0xF, //limite
		0x0, //available
		0x0, //codigo de 64-bit = 0
		0x1, //Dword/Byte
		0x1, //Granularity
		0x00},

 	// Descriptor 3: datos del kernel (4GB)
	{0xFFFF,
		0x0000,
		0x00,
		0x2, //no Ejecutable, Writable
		0x1, //no Sistema
		0x0, //DPL=0
		0x1, //Present
		0xF, //limite
		0x0,
		0x0,
		0x1, //Dword/Byte
		0x1, //Granularity
		0x00},

	// Descriptor 4: memoria de video (4000B)
	// XXX: era del TP2 de Orga-2, ya no se usa mas
	{0x0F9F,
		0x8000,
		0x0B,
		0x2,
		0x1,
		0x0,
		0x1,
		0x0,
		0x0,
		0x0,
		0x1,
		0x0,
		0x00},

	// Descriptor 5: codigo usuario (4GB)
	{0xFFFF,
		0x0000,
		0x00,
		0xA,
		0x1,
		0x3,
		0x1,
		0xF,
		0x0,
		0x0,
		0x1,
		0x1,
		0x00},

	// Descriptor 6: datos usuario (4GB)
	{0xFFFF,
		0x0000,
		0x00,
		0x2,
		0x1,
		0x3,
		0x1,
		0xF,
		0x0,
		0x0,
		0x1,
		0x1,
		0x00}
};

gdt_descriptor GDT_DESC = {sizeof(gdt)-1, (unsigned int)&gdt};
