#ifndef __GDT_H__
#define __GDT_H__

typedef struct str_gdt_descriptor {
	unsigned short gdt_length;
	unsigned int gdt_addr;
} __attribute__((__packed__)) gdt_descriptor;

typedef struct str_gdt_entry {
	unsigned short limit_0_15;
	unsigned short base_0_15;
	unsigned char base_23_16;
	unsigned char type:4;
	unsigned char s:1;
	unsigned char dpl:2;
	unsigned char p:1;
	unsigned char limit_16_19:4;
	unsigned char avl:1;
	unsigned char l:1;
	unsigned char db:1;
	unsigned char g:1;
	unsigned char base_31_24;
} __attribute__((__packed__, aligned (8))) gdt_entry;

extern gdt_entry gdt[];
extern gdt_descriptor GDT_DESC;

#define GDT_COUNT 128

#define GDT_IND2SEL(n,p)	((n)*8+(p))
#define GDT_SEL2IND(n,p)	(((n)-(p))/8)
#define GDT_IND_KRNCODE		2
#define GDT_IND_KRNDATA		3
#define GDT_IND_USRCODE		5
#define GDT_IND_USRDATA		6
#define GDT_SEL_KRNCODE		(GDT_IND2SEL(GDT_IND_KRNCODE, 0))
#define GDT_SEL_KRNDATA		(GDT_IND2SEL(GDT_IND_KRNDATA, 0))
#define GDT_SEL_USRCODE		(GDT_IND2SEL(GDT_IND_USRCODE, 3))
#define GDT_SEL_USRDATA		(GDT_IND2SEL(GDT_IND_USRDATA, 3))

#endif //__GDT_H__
