; vim:ft=nasm ts=4 sw=4
BITS 16

%include "macrosmodoreal.mac"

%define KORG 0x1200

global start

extern GDT_DESC, IDT_DESC
extern inicializar_idt, kmain

; Aca arranca todo, en el primer byte
start:
	; No me interrumpan por ahora, para el arranque
	cli
	jmp 	modoreal

; Mensaje de inicio
iniciando: db 'Iniciando el kernel del TP'
iniciando_len equ $ - iniciando		

modoreal:
	IMPRIMIR_MODO_REAL iniciando, iniciando_len, 0x07, 0, 0

	; Habilitar A20
	call	checkear_A20
	call 	habilitar_A20
	call	checkear_A20

	; Cargar la GDT, ya inicializada
	xor	ax, ax
	mov 	ds, ax
	lgdt	[GDT_DESC]

	; Paso a modo protegido
	mov	eax, cr0
	or	eax, 1
	mov	cr0, eax
	jmp	0x10:modoprot	; Indice 2 = codigo kernel

BITS 32
modoprot:
	; Ponemos los segmentos como corresponden
	mov	ax, 0x18	; Indice 3 = datos kernel
	mov	ds, ax
	mov	fs, ax
	mov 	gs, ax
	mov 	ss, ax
	;mov	ax, 0x20	; Indice 4 = memoria de video
	mov	es, ax

	; Inicializamos la pila
	mov	ebp, 0x19000
	mov 	esp, ebp
	
	; Y algunas cosas mas...
	mov	eax, cr4
	or	eax, 0x200	; Habilito SSE
	or	eax, 0x10	; Habilito paginas de 4MB
	mov 	cr4, eax

	call	inicializar_idt
	lidt	[IDT_DESC]

	; El resto esta en C, excepto algunos wrappers de interrupciones
	call kmain
	hlt

%include "a20.asm"

TIMES 0x2000 - KORG - ($ - $$) db 0x0
