#ifndef __KLIB_H__
#define __KLIB_H__

#include "stdlib.h"

// Macros para conjuntos en enteros (flags)

#define SET_INIT(s)	((s) = 0)
#define SET_NUM2FLAG(x)	((unsigned)1 << (x))
#define SET_ADD(s,x)	((s) |= SET_NUM2FLAG(x))
#define SET_REMOVE(s,x)	((s) &= ~SET_NUM2FLAG(x))
#define SET_TOGGLE(s,x)	((s) ^= SET_NUM2FLAG(x))
#define SET_TEST(s,x)	(((s) & SET_NUM2FLAG(x)) ? 1 : 0)

#ifndef NDEBUG
#define kassert(expr)	((expr) ? (void)0 : kpanic("%s:%d: Assertion failed: %s\n", __FILE__, __LINE__, #expr))
#else
#define kassert(expr)	(void)0
#endif

#define SCREEN ((void*)0xB8000)

// TODO: hacer inline, porque son de bajo nivel y corren en interrupciones
void scr_write(const char*, unsigned, unsigned, unsigned);
void scr_writeln(const char* msg, unsigned format, unsigned row, unsigned col);
void scr_putch(char ch, int format, int row, int col);
void scr_repch(char ch, int row, int col);

void kpanic(const char *format, ...);
void upanic(const char *format, ...);
void circular_read(const void *buffer, int size, int offset, int ammount, void *to);
int copyInPages(void **dest, int maxPages, const void *source, int size);

#define getcons sys_getcons
#define getpid sys_getpid

#endif
