#include "klib.h"
#include "mmu.h"
#include "loader.h"
#include "pic.h"
#include "consola.h"
#include "pak.h"

typedef struct {
	void *func;
	int numArgs;
} syscall_t;

syscall_t syscalls_tabla[] = {
	{&sys_puts, 1},
	{&sys_ngets, 2},
	{&sys_exit, 1},
	{&sys_getpid, 0},
	{&sys_getcons, 0},
	{&sys_ls, 0},
	{&sys_exec, 2},
	{&sys_ps, 0},
	{&sys_kill, 1}
};
unsigned syscalls_cant = sizeof(syscalls_tabla)/sizeof(*syscalls_tabla);

void *dirPagsKernel;

void kmain() {
	mmu_inicializar();
	cons_inicializar();

	resetear_pic();
	habilitar_pic();
	
	loader_inicializar();

	// FIXME: pasar a modo usuario con un IRET?
	sti();
	for (;;)
		;
}
