#ifndef __LOADER_H__
#define __LOADER_H__

#include "gdt.h"
#include "pak.h"

#define GDT_IND_PROCESOS	7
#define MAX_PROCESOS		13	// idle task + 12 (uno para cada consola)

#define PID_A_TR(x)	GDT_IND2SEL((x)+GDT_IND_PROCESOS, 3)
#define TR_A_PID(x)	(GDT_SEL2IND(x, 3) - GDT_IND_PROCESOS)

#define PID_IDLE	0
#define PID_SHELL	1

enum sched_flags {
	SCH_PRESENTE, SCH_BLOQUEADA, SCH_TERMINADA, SCH_OCULTA
};

#define MAX_PROC_PAGES 2
typedef struct {
	int flags;
	const char *name;
	int quantum;
	int consola;

	// Mapa de memoria
	void *dir_pags;
	void *pila_usuario;
	void *pila_kernel;
	void *codigo[MAX_PROC_PAGES];
	int cant_codigo;
} proceso_t;

void loader_inicializar();
int loader_exec(const char *name, int quantum);
int loader_exec_batch(const char *name, int quantum);
void loader_kill(int pid);

extern int num_procesos;
extern proceso_t procesos[];

int sched_block(int pid);
void sched_unblock(int pid);
void sched_kill(int pid, int status);

#endif
