#ifndef _PAK_H_
#define _PAK_H_

#define PAK_MAGIC 0xDEADFE05
#define PAK_MAX_NAME 32

typedef struct {
	int magic;
	int num_entries;
} pak_header_t;

typedef struct {
	char name[PAK_MAX_NAME];
	int position;
	int size;
} pak_entry_t;

void pak_init();
const pak_entry_t* pak_find(const char *name);
void pak_copyTo(const char *name, void *dest);
int pak_copyToPages(const char *name, void **dest, int maxPages);
int pak_list(int num_cons);

#endif
