#ifndef __USRCALLS_H__
#define __USRCALLS_H__

#include "i386.h"

// Definiciones varias

#define NULL ((void*)0)
#define true 1
#define false 0
#define MIN(a,b) ((a) < (b) ? (a) : (b))
#define MAX(a,b) ((a) > (b) ? (a) : (b))
#define ARRAY_SIZEOF(x)	(sizeof(x)/sizeof(x[0]))
#define ERR_PERM (-1)
#define ERR_NOENT (-2)
#define ERR_MAX (-2)

// Argumentos variables para printf() y similares, compatible con stdarg.h (parte del standard de C)

typedef int *va_list;
#define va_start(vl, arg)	(vl = (int*)&arg+1)
#define va_arg(vl, type)	(*((type*)_va_arg(&vl)))

LS_INLINE va_list _va_arg(va_list *vl) {
	va_list ret = (*vl)++;
	return ret;
}

#define va_end(vl)		(vl = NULL)

// Rutinas de usuario, en stdlib.c
char *strcat(char *dst, const char *src);
int strcmp(const char *s1, const char *s2);
int strpartcmp(const char *s1, const char *s2);
int strncmp(const char *s1, const char *s2, unsigned len);
int strlen(const char *s);
int strlcpy(char *dst, const char *src, int size);
int printf(const char *format, ...);
int snprintf(char *buffer, int size, const char *format, ...);
int vsnprintf(char *buffer, int size, const char *format, va_list ap);
int itostr(unsigned x, int base, char *buf);
void memcpy(char*, const char*, unsigned);
void memcpyw(short* dst, const short* src, unsigned len);
void memset(char *dst, char c, unsigned len);
void memsetw(short *dst, short w, unsigned len);
void memsetdw(int *dst, int dw, unsigned len);
int strtoi(const char *str, int base);
int readInt();
void srand(unsigned long long *seed);
unsigned long rand(unsigned long long *seed);

// System calls, en syscalls.asm
void sys_puts(const char *mensaje);
int sys_ngets(char *buf, int size);
void sys_exit(int status);
int sys_getpid();
int sys_getcons();
int sys_ls();
int sys_exec(const char *name, int quantum);
int sys_ps();
int sys_kill(int pid);

#if defined(__userspace) && !defined(__nostart)
// Lo primero del codigo de cada tarea debe ser esto,
// asi no importa si definimos main() al comienzo y ademas le permitimos retornar.
int main();
void start() {
	int st = main();
	sys_exit(st);
}
#endif

#endif
